package edu.byu.cs.woodfiel.catalogdemo;

import android.content.res.AssetManager;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.Button;

import org.json.JSONException;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import edu.byu.cs.woodfiel.catalogdemo.database.CD_DAO;
import edu.byu.cs.woodfiel.catalogdemo.database.DataImporter;
import edu.byu.cs.woodfiel.catalogdemo.database.Database;
import edu.byu.cs.woodfiel.catalogdemo.database.DbOpenHelper;
import edu.byu.cs.woodfiel.catalogdemo.model.Catalog;

public class MainActivity extends AppCompatActivity {
    private Catalog catalog;
    private SQLiteDatabase database;

    //GUI Components
    private Button mEmptyButton;
    private Button mLoadButton;
    private Button mPopulateButton;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

    //GUI Component setup.
    //If you read chapter 1 of the book you should be able to understand this section,
    //res.layout.activity_main.xml, and the strings in res.values.strings.xml
        mEmptyButton = (Button) findViewById(R.id.empty_button);
        mLoadButton = (Button) findViewById(R.id.load_button);
        mPopulateButton = (Button) findViewById(R.id.populate_button);

        mEmptyButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CD_DAO.SINGLETON.emptyCDs();
            }
        });

        mLoadButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                try {
                    AssetManager manager = getBaseContext().getAssets();
                    InputStream input = manager.open(JSON_FILE_NAME);
                    InputStreamReader reader = new InputStreamReader(input);
                    DataImporter.SINGLETON.importData(reader);
                } catch (JSONException e) {
                    e.printStackTrace();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });

        mPopulateButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Catalog catalog = new Catalog();
            }
        });

        DbOpenHelper dbOpenHelper = new DbOpenHelper(getBaseContext());
        database = dbOpenHelper.getWritableDatabase();
        CD_DAO.SINGLETON.setDB(database);
    }

    private static final String JSON_FILE_NAME = "cd_catalog.json";
}
