package edu.byu.cs.woodfiel.catalogdemo.database;

import android.content.res.AssetManager;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;

import edu.byu.cs.woodfiel.catalogdemo.model.CD;

/**
 * Created by Scott on 2/9/2016.
 */
public class DataImporter {
    public static final DataImporter SINGLETON = new DataImporter();

    public void importData(InputStreamReader reader)
            throws org.json.JSONException, IOException
    {
        JSONObject rootObject = new JSONObject(makeString(reader));
        JSONArray cdArr = null;
        try {
            cdArr = rootObject.getJSONArray("CATALOG");
            for (int i = 0; i < cdArr.length(); ++i) {
                JSONObject elemObj = cdArr.getJSONObject(i);
                JSONObject cdObj = elemObj.getJSONObject("CD");
                CD cd = new CD(cdObj);
                CD_DAO.SINGLETON.addCD(cd);
            }
        } catch (JSONException e) {
            e.printStackTrace();
        }
    }


    private static String makeString(Reader reader) throws IOException {

        StringBuilder sb = new StringBuilder();
        char[] buf = new char[512];

        int n = 0;
        while ((n = reader.read(buf)) > 0) {
            sb.append(buf, 0, n);
        }

        return sb.toString();
    }

}
